diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index f1e10fa1b..58981b96e 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -10,7 +10,6 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -20,7 +19,7 @@ import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveFormatBase;
-import net.minecraft.core.world.save.SaveHandlerClientMP;
+import net.minecraft.client.world.save.SaveHandlerClientMP;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 8e339a871..70bd167ab 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -27,6 +27,8 @@ import net.minecraft.client.gui.chat.ScreenSleepMP;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
+import net.minecraft.client.sound.SoundEvent;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.BlockLeavesBase;
@@ -100,7 +102,7 @@ import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.render.window.GameWindow;
 import net.minecraft.client.render.window.GameWindowGLFW;
 import net.minecraft.client.sound.SoundEngine;
-import net.minecraft.client.util.debug.Debug;
+import net.minecraft.core.util.debug.Debug;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.util.helper.ScreenshotHelper;
 import net.minecraft.client.util.helper.Textures;
@@ -188,7 +190,7 @@ public class Minecraft
     public boolean hasCrashed;
     public UnexpectedThrowable lastCrash;
     private final Timer timer;
-    public World theWorld;
+    public WorldClient currentWorld;
     public RenderGlobal renderGlobal;
     public PlayerLocal thePlayer;
     public ICamera activeCamera;
@@ -522,7 +524,7 @@ public class Minecraft
         TextureRegistry.blockAtlas.bind();
         renderGlobal = new RenderGlobal(this, textureManager);
         glViewport(0, 0, gameWindow.getWidthPixels(), gameWindow.getHeightPixels());
-        particleEngine = new ParticleEngine(theWorld);
+        particleEngine = new ParticleEngine(currentWorld);
         try
         {
             LOGGER.info("Starting Resource Download Thread...");
@@ -807,7 +809,7 @@ public class Minecraft
         if(statsCounter != null){
             statsCounter.saveStats();
         }
-        if(screen == null && theWorld == null)
+        if(screen == null && currentWorld == null)
         {
             screen = new ScreenMainMenu();
         }
@@ -899,7 +901,7 @@ public class Minecraft
                     Vec3.initializePool();
                     
                     if(gameWindow.shouldClose()) shutdown();
-                    if(isGamePaused && theWorld != null && !(currentScreen instanceof ScreenModelViewer))
+                    if(isGamePaused && currentWorld != null && !(currentScreen instanceof ScreenModelViewer))
                     {
                         float temp = timer.partialTicks;
                         timer.advanceTime();
@@ -929,7 +931,7 @@ public class Minecraft
                         }
                         catch(MinecraftException e)
                         {
-                            theWorld = null;
+                            currentWorld = null;
                             LOGGER.error("MinecraftException occurred while attempting to run tick, exiting world!", e);
                         }
                         changeWorld(null);
@@ -945,11 +947,11 @@ public class Minecraft
                     BlockLeavesBase.enableTreeShadowing = gameSettings.treeShadows.value;
                     sndManager.updateListener(thePlayer, timer.partialTicks);
                     glEnable(GL_TEXTURE_2D);
-                    if(theWorld != null)
+                    if(currentWorld != null)
                     {
                     	Debug.change("updatelight");
                         try {
-                            theWorld.updatingLighting();
+                            currentWorld.updatingLighting();
                         } catch (Throwable t) {
                             LOGGER.error("Unhandled exception when updating lighting!", t);
                         }
@@ -1017,7 +1019,7 @@ public class Minecraft
                         currentTime += 1000L;
                         fpsCounter = 0;
                     }
-					if(theWorld == null) {
+					if(currentWorld == null) {
 						long now = System.currentTimeMillis();
 						// Limit FPS in menu
 						long sleepTime = (1000 / 60 - (now - tickStartTime)) - 1;
@@ -1036,7 +1038,7 @@ public class Minecraft
                 }
                 catch(MinecraftException minecraftexception)
                 {
-                    theWorld = null;
+                    currentWorld = null;
                     changeWorld(null);
                     displayScreen(new ScreenConflictWarning());
                 }
@@ -1048,7 +1050,7 @@ public class Minecraft
                 }
                 catch(Throwable throwable)
                 {
-                    if (theWorld != null) {
+                    if (currentWorld != null) {
                         try {
                             changeWorld(null);
                         } catch (Throwable t) {
@@ -1227,7 +1229,7 @@ public class Minecraft
                     double xPlaced = 0.5d;
                     ItemStack stack = this.thePlayer.inventory.getCurrentItem();
                     int numItemsInStack = stack == null ? 0 : stack.stackSize;
-                    if (this.playerController.useItemOn(thePlayer, theWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
+                    if (this.playerController.useItemOn(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced)) {
                         this.playerController.swingItem(true);
                     }
                     if (stack == null) {
@@ -1285,7 +1287,7 @@ public class Minecraft
             {
                 ItemStack stack = thePlayer.inventory.getCurrentItem();
                 int numItemsInStack = stack == null ? 0 : stack.stackSize;
-                if(playerController.useItemOn(thePlayer, theWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced))
+                if(playerController.useItemOn(thePlayer, currentWorld, stack, blockX, blockY, blockZ, side, xPlaced, yPlaced))
                 {
                     flag = false;
                     playerController.swingItem(true);
@@ -1307,7 +1309,7 @@ public class Minecraft
         if(flag && clickType == 1)
         {
             ItemStack itemstack = thePlayer.inventory.getCurrentItem();
-            if(itemstack != null && playerController.useItem(thePlayer, theWorld, itemstack))
+            if(itemstack != null && playerController.useItem(thePlayer, currentWorld, itemstack))
             {
                 worldRenderer.itemRenderer.resetEquippedProgress();
             }
@@ -1368,12 +1370,12 @@ public class Minecraft
         worldRenderer.getMouseOver(1.0F);
         if(thePlayer != null)
         {
-            IChunkProvider chunkProvider = theWorld.getChunkProvider();
+            IChunkProvider chunkProvider = currentWorld.getChunkProvider();
             int playerChunkX = MathHelper.floor_float((int)thePlayer.x) >> 4;
             int playerChunkZ = MathHelper.floor_float((int)thePlayer.z) >> 4;
             chunkProvider.setCurrentChunkOver(playerChunkX, playerChunkZ);
         }
-        if(!isGamePaused && theWorld != null)
+        if(!isGamePaused && currentWorld != null)
         {
             playerController.tick();
         }
@@ -1387,9 +1389,9 @@ public class Minecraft
             {
                 displayScreen(null);
             }
-            else if(thePlayer.isPlayerSleeping() && theWorld != null)
+            else if(thePlayer.isPlayerSleeping() && currentWorld != null)
             {
-                if(theWorld.isClientSide)
+                if(currentWorld.isClientSide)
                 {
                     displayScreen(new ScreenSleepMP());
                 }
@@ -1535,7 +1537,7 @@ public class Minecraft
                             }
                             else if(gameSettings.keySwitchGamemode.isPressEvent())
                             {
-                                if (theWorld.getLevelData().getCheatsEnabled() || theWorld.isClientSide)
+                                if (currentWorld.getLevelData().getCheatsEnabled() || currentWorld.isClientSide)
                                 {
                                     if (thePlayer.getGamemode() == Gamemode.creative)
                                     {
@@ -1568,7 +1570,7 @@ public class Minecraft
                                 }
                                 else
                                 {
-                                    if (theWorld.getLevelData().getCheatsEnabled())
+                                    if (currentWorld.getLevelData().getCheatsEnabled())
                                     {
                                         fullbright = !fullbright;
                                         if(!LightmapHelper.isLightmapEnabled()) {
@@ -1664,7 +1666,7 @@ public class Minecraft
             handleControllerInput();
         }
         Debug.change("misc");
-        if(theWorld != null)
+        if(currentWorld != null)
         {
             if(thePlayer != null)
             {
@@ -1672,7 +1674,7 @@ public class Minecraft
                 if(joinPlayerCounter == 30)
                 {
                     joinPlayerCounter = 0;
-                    theWorld.joinEntityInSurroundings(thePlayer);
+                    currentWorld.joinEntityInSurroundings(thePlayer);
                 }
                 thePlayer.setFlySpeed(gameSettings.flightSpeed.value);
                 thePlayer.setFlightSmoothness(gameSettings.flightSmoothness.value);
@@ -1689,12 +1691,12 @@ public class Minecraft
             if(!isGamePaused)
             {
                 Debug.change("entity");
-                if(theWorld.lightningFlicker > 0)
+                if(currentWorld.lightningFlicker > 0)
                 {
-                    theWorld.lightningFlicker--;
+                    currentWorld.lightningFlicker--;
                 }
                 try {
-                    theWorld.updateEntities();
+                    currentWorld.updateEntities();
                 } catch (StackOverflowError stackOverflowError) {
                     LOGGER.error("Stack overflow while updating world entities! Closing world!", stackOverflowError);
                     changeWorld(null);
@@ -1710,7 +1712,7 @@ public class Minecraft
             {
                 Debug.change("world");
                 try {
-                    theWorld.tick();
+                    currentWorld.tick();
                 } catch (StackOverflowError stackOverflowError) {
                     LOGGER.error("Stack overflow while updating world entities! Closing world!", stackOverflowError);
                     changeWorld(null);
@@ -1722,10 +1724,10 @@ public class Minecraft
                 }
                 Debug.change("misc");
             }
-            if(!isGamePaused && theWorld != null)
+            if(!isGamePaused && currentWorld != null)
             {
                 Debug.change("randomDisplayTick");
-                theWorld.randomDisplayUpdates(MathHelper.floor(thePlayer.x), MathHelper.floor(thePlayer.y), MathHelper.floor(thePlayer.z));
+                currentWorld.randomDisplayUpdates(MathHelper.floor(thePlayer.x), MathHelper.floor(thePlayer.y), MathHelper.floor(thePlayer.z));
                 Debug.change("misc");
             }
             if(!isGamePaused)
@@ -2103,7 +2105,7 @@ public class Minecraft
 
     public boolean isMultiplayerWorld()
     {
-        return theWorld != null && theWorld.isClientSide;
+        return currentWorld != null && currentWorld.isClientSide;
     }
 
     public void startWorld(String worldDirName, String worldName, long seed)
@@ -2150,7 +2152,7 @@ public class Minecraft
                     }
                 }
             }
-            World world = new World(saveHandler, worldName, seed, null, null);
+            WorldClient world = new WorldClient(saveHandler, worldName, seed, null, null);
             if(world.isNewWorld)
             {
                 statsCounter.add(StatList.createWorldStat, 1);
@@ -2171,7 +2173,7 @@ public class Minecraft
         Dimension newDim = Dimension.getDimensionList().get(dim);
         LOGGER.info("Switching to dimension \"{}\"!!", newDim.getTranslatedName());
         thePlayer.dimension = dim;
-        theWorld.setEntityDead(thePlayer);
+        currentWorld.setEntityDead(thePlayer);
         thePlayer.removed = false;
         double x = thePlayer.x;
         double z = thePlayer.z;
@@ -2193,9 +2195,9 @@ public class Minecraft
         thePlayer.dimensionEnterCoordinate = newCoordinates;
         if(thePlayer.isAlive())
         {
-            theWorld.updateEntityWithOptionalForce(thePlayer, false);
+            currentWorld.updateEntityWithOptionalForce(thePlayer, false);
         }
-        World world = new World(theWorld, newDim);
+        WorldClient world = new WorldClient(currentWorld, newDim);
 
         I18n i18n = I18n.getInstance();
         if (newDim == lastDim.homeDim)
@@ -2207,26 +2209,26 @@ public class Minecraft
             changeWorld(world, i18n.translateKeyAndFormat("gui.loading.label.entering", newDim.getTranslatedName()), thePlayer);
         }
 
-        thePlayer.world = theWorld;
+        thePlayer.world = currentWorld;
         if(thePlayer.isAlive())
         {
             thePlayer.moveTo(x, y, z, thePlayer.yRot, thePlayer.xRot);
-            theWorld.updateEntityWithOptionalForce(thePlayer, false);
-            (new PortalHandler()).teleportEntity(theWorld, thePlayer, portalColor, lastDim, newDim);
+            currentWorld.updateEntityWithOptionalForce(thePlayer, false);
+            (new PortalHandler()).teleportEntity(currentWorld, thePlayer, portalColor, lastDim, newDim);
         }
     }
 
-    public void changeWorld(World world)
+    public void changeWorld(WorldClient world)
     {
         changeWorld(world, "");
     }
 
-    public void changeWorld(World world, String loadingTitle)
+    public void changeWorld(WorldClient world, String loadingTitle)
     {
         changeWorld(world, loadingTitle, null);
     }
 
-    public void changeWorld(World world, String loadingTitle, Player player)
+    public void changeWorld(WorldClient world, String loadingTitle, Player player)
     {
     	mainMenuBackground.deleteTextures();
     	gameSettings.showCollisionBoxes.value = false;
@@ -2243,11 +2245,11 @@ public class Minecraft
         }
 
         sndManager.stopMusic();
-        if(theWorld != null)
+        if(currentWorld != null)
         {
-            theWorld.saveWorldIndirectly(loadingScreen);
-            if (theWorld.saveHandler != null) {
-                IChunkLoader loader = theWorld.saveHandler.getChunkLoader(theWorld.dimension);
+            currentWorld.saveWorldIndirectly(loadingScreen);
+            if (currentWorld.saveHandler != null) {
+                IChunkLoader loader = currentWorld.saveHandler.getChunkLoader(currentWorld.dimension);
                 if (loader != null) {
                     while (loader.isSaving()) {
                         try {
@@ -2257,12 +2259,12 @@ public class Minecraft
                         }
                     }
                 }
-                theWorld.getChunkProvider().unloadAllChunks();
-                theWorld.onUnload();
+                currentWorld.getChunkProvider().unloadAllChunks();
+                currentWorld.onUnload();
             }
         }
-        theWorld = world;
-        if(theWorld != null) {
+        currentWorld = world;
+        if(currentWorld != null) {
             Colorizers.update(true);
         }
         if(world != null)
@@ -2371,15 +2373,15 @@ public class Minecraft
 
     private void prepareLevel(String loadingTitle)
     {
-        loadingScreen.updateLoadingBackground(theWorld.dimension);
+        loadingScreen.updateLoadingBackground(currentWorld.dimension);
         loadingScreen.progressStartNoAbort(loadingTitle);
         loadingScreen.progressStage("Building terrain");
         char c = 128;
         int i = 0;
         int j = (c * 2) / 16 + 1;
         j *= j;
-        IChunkProvider ichunkprovider = theWorld.getChunkProvider();
-        ChunkCoordinates chunkcoordinates = theWorld.getSpawnPoint();
+        IChunkProvider ichunkprovider = currentWorld.getChunkProvider();
+        ChunkCoordinates chunkcoordinates = currentWorld.getSpawnPoint();
         if(thePlayer != null)
         {
             chunkcoordinates.x = (int)thePlayer.x;
@@ -2391,8 +2393,8 @@ public class Minecraft
             for(int l = -c; l <= c; l += Chunk.CHUNK_SIZE_Z)
             {
                 loadingScreen.progressStagePercentage((i++ * 100) / j);
-                theWorld.getBlockId(chunkcoordinates.x + k, 64, chunkcoordinates.z + l);
-                while(theWorld.updatingLighting()) ;
+                currentWorld.getBlockId(chunkcoordinates.x + k, 64, chunkcoordinates.z + l);
+                while(currentWorld.updatingLighting()) ;
             }
 
         }
@@ -2400,7 +2402,7 @@ public class Minecraft
         loadingScreen.progressStage("Simulating world for a bit...");
         loadingScreen.progressStop();
         j = 2000;
-        theWorld.dropOldChunks();
+        currentWorld.dropOldChunks();
     }
 
     public String getRendererDebugInfo()
@@ -2415,18 +2417,18 @@ public class Minecraft
 
     public String getChunkProviderInfoString()
     {
-        return theWorld.getChunkProviderInfoString();
+        return currentWorld.getChunkProviderInfoString();
     }
     
     public String getEntityCountsInfoString()
     {
-        return "P: " + particleEngine.countParticles() + ". T: " + theWorld.getNumLoadedEntitiesString();
+        return "P: " + particleEngine.countParticles() + ". T: " + currentWorld.getNumLoadedEntitiesString();
     }
 
     public void respawn(boolean multiplayer, int targetDimension)
     {
     	@Nullable Player previousPlayer = thePlayer;
-        if(!theWorld.isClientSide && !theWorld.dimension.defaultWorldType.mayRespawn())
+        if(!currentWorld.isClientSide && !currentWorld.dimension.defaultWorldType.mayRespawn())
         {
             usePortal(targetDimension, null);
         }
@@ -2441,7 +2443,7 @@ public class Minecraft
             lastDeathCoordinates = thePlayer.getLastDeathCoordinate();
             if(spawnCoordinates != null)
             {
-                bedSpawnCoordinates = Player.getValidBedSpawnCoordinates(theWorld, spawnCoordinates);
+                bedSpawnCoordinates = Player.getValidBedSpawnCoordinates(currentWorld, spawnCoordinates);
                 if(bedSpawnCoordinates == null)
                 {
                     thePlayer.sendTranslatedChatMessage("bed.notValid");
@@ -2450,22 +2452,22 @@ public class Minecraft
         }
         if(bedSpawnCoordinates == null)
         {
-            bedSpawnCoordinates = theWorld.getSpawnPoint();
+            bedSpawnCoordinates = currentWorld.getSpawnPoint();
             canRespawnAtBed = false;
         }
-        IChunkProvider ichunkprovider = theWorld.getChunkProvider();
+        IChunkProvider ichunkprovider = currentWorld.getChunkProvider();
         ichunkprovider.setCurrentChunkOver(bedSpawnCoordinates.x >> 4, bedSpawnCoordinates.z >> 4);
-        theWorld.getRespawnLocation();
-        theWorld.updateEntityList();
+        currentWorld.getRespawnLocation();
+        currentWorld.updateEntityList();
         int j = 0;
         Gamemode playerGamemode = Gamemode.survival;
         if(thePlayer != null)
         {
             j = thePlayer.id;
-            theWorld.setEntityDead(thePlayer);
+            currentWorld.setEntityDead(thePlayer);
             playerGamemode = thePlayer.getGamemode();
         }
-        thePlayer = (PlayerLocal)playerController.createPlayer(theWorld);
+        thePlayer = (PlayerLocal)playerController.createPlayer(currentWorld);
         thePlayer.dimension = targetDimension;
         thePlayer.setGamemode(playerGamemode);
         if (previousPlayer != null && previousPlayer.getHeldObject() != null) {
@@ -2478,7 +2480,7 @@ public class Minecraft
         
         if(previousPlayer != null) {
             thePlayer.messageHistory = previousPlayer.messageHistory;
-        	if(!theWorld.isClientSide) {
+        	if(!currentWorld.isClientSide) {
         		thePlayer.inventory.transferAllContents(previousPlayer.inventory);
         	}
         }
@@ -2490,7 +2492,7 @@ public class Minecraft
         }
         thePlayer.setLastDeathCoordinate(lastDeathCoordinates);
         playerController.initPlayer(thePlayer);
-        theWorld.spawnPlayerWithLoadedChunks(thePlayer);
+        currentWorld.spawnPlayerWithLoadedChunks(thePlayer);
         thePlayer.input = new PlayerInput(this);
         thePlayer.id = j;
         thePlayer.animate4();
@@ -2673,11 +2675,17 @@ public class Minecraft
         }
     }
 
+
     @Override
     public SkinVariantList getSkinVariantList() {
         return skinVariantList;
     }
 
+    @Override
+    public Collection<String> getAvailableSoundKeys() {
+        return SoundRepository.allKeys;
+    }
+
     public boolean isAmbientOcclusionEnabled()
     {
         return gameSettings.ambientOcclusion.value;
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index e956b0a20..212d9267e 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -145,7 +145,7 @@ public class RichPresenceHandlerThread extends Thread {
         activity.assets().setLargeImage("bta-logo");
         activity.timestamps().setStart(startTime);
 
-        if (minecraft.theWorld == null) {
+        if (minecraft.currentWorld == null) {
             activity.setState("In the main menu");
         } else if (minecraft.thePlayer != null) {
             if (minecraft.thePlayer instanceof PlayerLocalMultiplayer) {
@@ -161,8 +161,8 @@ public class RichPresenceHandlerThread extends Thread {
                 }
             }
             Dimension activeDimension = Dimension.getDimensionList().get(minecraft.thePlayer.dimension);
-            Biome biome = minecraft.theWorld.getBlockBiome((int) minecraft.thePlayer.x, (int) minecraft.thePlayer.y, (int) minecraft.thePlayer.z);
-            Weather weather = minecraft.theWorld.getCurrentWeather();
+            Biome biome = minecraft.currentWorld.getBlockBiome((int) minecraft.thePlayer.x, (int) minecraft.thePlayer.y, (int) minecraft.thePlayer.z);
+            Weather weather = minecraft.currentWorld.getCurrentWeather();
 
             boolean displayDimension = activeDimension != null && dimensionNamesMap.containsKey(activeDimension);
             boolean displayBiome = biome != null && biomeNamesMap.containsKey(biome);
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index d0bd0297e..32d9a47d9 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -4,11 +4,13 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.net.command.arguments.ArgumentTypeParticleId;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -16,7 +18,7 @@ import java.util.ArrayList;
 import java.util.List;
 
 public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
-    private static final ParticleDispatcher INSTANCE = new ParticleDispatcher();
+    private static ParticleDispatcher INSTANCE = new ParticleDispatcher();
     private static final ParticleLambda BLANK = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
 
     public static ParticleDispatcher getInstance() {
@@ -33,6 +35,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
     }
 
     private ParticleDispatcher() {
+        INSTANCE = this;
         Minecraft mc = Minecraft.getMinecraft(this);
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true));
         addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX));
@@ -46,7 +49,8 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFootstep(mc.textureManager, world, x, y, z));
         addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new ParticleSplash(world1, d, d1, d2, d3, d4, d5));
         addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f));
-        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
+        addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
         addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionX));
@@ -74,5 +78,14 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
             return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
         });
         addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright());
+
+        if (Global.ASSERTIONS_ENABLED) {
+            for (String s : INSTANCE.getParticleIds()) {
+                assert ArgumentTypeParticleId.particleIds.contains(s) : "ArgumentTypeParticleId is missing id " + s + "!";
+            }
+            for (String s : ArgumentTypeParticleId.particleIds) {
+                assert dispatches.containsKey(s) : "ArgumentTypeParticleId defined particle " + s + " which doesn't have an assigned particle lambda!";
+            }
+        }
     }
 }
